=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-09-16 03:32:44 +0000
+++ bzrlib/selftest/__init__.py	2005-09-16 12:59:36 +0000
@@ -244,12 +244,19 @@
         pass a list instead."""
         cmd = self._formcmd(cmd)
         self.log('$ ' + ' '.join(cmd))
-        actual_retcode = subprocess.call(cmd, stdout=self._log_file,
-                                         stderr=self._log_file)
+        child = subprocess.Popen(cmd, stdout=subprocess.PIPE,
+                                                       stderr=subprocess.PIPE)
+        outd, errd = child.communicate()
+        self.log(outd)
+        self.log(errd)
+
+        actual_retcode = child.wait()
         if retcode != actual_retcode:
             raise CommandFailed("test failed: %r returned %d, expected %d"
                                 % (cmd, actual_retcode, retcode))
 
+        return outd, errd
+
     def backtick(self, cmd, retcode=0):
         """Run a command and return its output"""
         cmd = self._formcmd(cmd)

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-09-16 03:32:44 +0000
+++ bzrlib/selftest/blackbox.py	2005-09-16 12:59:36 +0000
@@ -26,6 +26,7 @@
 it's normally invoked.
 """
 
+from cStringIO import StringIO
 import sys
 import os
 
@@ -256,21 +257,16 @@
         os.chdir('../b')
         self.runbzr('pull ../a')
         assert a.revision_history()[-1] == b.revision_history()[-1]
-        
 
     def test_add_reports(self):
         """add command prints the names of added files."""
         b = Branch.initialize('.')
         self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
-
-        from cStringIO import StringIO
         out = StringIO()
-
         ret = self.apply_redirected(None, out, None,
                                     run_bzr,
                                     ['add'])
         self.assertEquals(ret, 0)
-
         # the ordering is not defined at the moment
         results = sorted(out.getvalue().rstrip('\n').split('\n'))
         self.assertEquals(['added dir',

